| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
ResidEval Class Referenceabstract

Virtual base class for DAE residual function evaluators. More...

`#include <ResidEval.h>`

Inheritance diagram for ResidEval:
[legend]

## Detailed Description

Virtual base class for DAE residual function evaluators.

Classes derived from ResidEval evaluate the residual function

\[ \vec{F}(t,\vec{y}, \vec{y^\prime}) \]

The DAE solver attempts to find a solution y(t) such that F = 0.

Deprecated:
  Unused. To be removed after Cantera 3.0.

Definition at line 38 of file ResidEval.h.

## Public Member Functions
virtual void | constrain (const int k, const int flag)
| Constrain solution component k.
int | constraint (const int k) const
virtual void | initSizes ()
| Initialization function.
virtual void | setAlgebraic (const int k)
| Specify that solution component k is purely algebraic - that is, the derivative of this component does not appear in the residual function.
virtual bool | isAlgebraic (const int k)
virtual int | eval (const double t, const double *const y, const double *const ydot, double *const r)
| Evaluate the residual function.
virtual int | evalSS (const double t, const double *const y, double *const r)
virtual int | evalSimpleTD (const double t, const double *const y, const double *const yold, double deltaT, double *const r)
virtual int | getInitialConditions (const double t0, double *const y, double *const ydot)
| Fill in the initial conditions.
virtual int | nEquations () const =0
| Return the number of equations in the equation system.
virtual void | writeSolution (int ievent, const double time, const double deltaT, const int time_step_num, const double *y, const double *ydot)
| Write out to a file or to standard output the current solution.
int | nparams () const
| Return the number of parameters in the calculation.

## Protected Attributes
vector< int > | m_alg
| Mapping vector that stores whether a degree of freedom is a DAE or not.
map< int, int > | m_constrain

## Constructor & Destructor Documentation

## ◆ ResidEval()

ResidEval | ( |  | ) |
| inline

Definition at line 41 of file ResidEval.h.

## ◆ ~ResidEval()

virtual ~ResidEval | ( |  | ) |
| inline virtual

Definition at line 44 of file ResidEval.h.

## Member Function Documentation

## ◆ constrain()

virtual void constrain | ( | const int | k,
|  | const int | flag
| ) |  |
| inline virtual

Constrain solution component k.

Possible values for 'flag' are:

- c_NONE no constraint
- c_GE_ZERO >= 0
- c_GT_ZERO > 0
- c_LE_ZERO <= 0
- c_LT_ZERO < 0

Definition at line 55 of file ResidEval.h.

## ◆ constraint()

int constraint | ( | const int | k | ) | const
| inline

Definition at line 58 of file ResidEval.h.

## ◆ initSizes()

virtual void initSizes | ( |  | ) |
| inline virtual

Initialization function.

Definition at line 63 of file ResidEval.h.

## ◆ setAlgebraic()

virtual void setAlgebraic | ( | const int | k | ) |
| inline virtual

Specify that solution component k is purely algebraic - that is, the derivative of this component does not appear in the residual function.

Definition at line 72 of file ResidEval.h.

## ◆ isAlgebraic()

virtual bool isAlgebraic | ( | const int | k | ) |
| inline virtual

Definition at line 79 of file ResidEval.h.

## ◆ eval()

virtual int eval | ( | const double | t,
|  | const double *const | y,
|  | const double *const | ydot,
|  | double *const | r
| ) |  |
| inline virtual

Evaluate the residual function.

Called by the integrator.

Parameters

  t | time. (input)
  y | solution vector. (input)
  ydot | rate of change of solution vector. (input)
  r | residual vector (output)

Reimplemented in ResidJacEval.

Definition at line 90 of file ResidEval.h.

## ◆ evalSS()

virtual int evalSS | ( | const double | t,
|  | const double *const | y,
|  | double *const | r
| ) |  |
| inline virtual

Definition at line 96 of file ResidEval.h.

## ◆ evalSimpleTD()

virtual int evalSimpleTD | ( | const double | t,
|  | const double *const | y,
|  | const double *const | yold,
|  | double | deltaT,
|  | double *const | r
| ) |  |
| inline virtual

Definition at line 101 of file ResidEval.h.

## ◆ getInitialConditions()

virtual int getInitialConditions | ( | const double | t0,
|  | double *const | y,
|  | double *const | ydot
| ) |  |
| inline virtual

Fill in the initial conditions.

Values for both the solution and the value of ydot may be provided.

Parameters

  [in] | t0 | Time
  [out] | y | Solution vector
  [out] | ydot | Rate of change of solution vector.

Returns
  a flag to indicate that operation is successful. 1 Means a successful operation -0 or neg value Means an unsuccessful operation

Reimplemented in ResidJacEval.

Definition at line 124 of file ResidEval.h.

## ◆ nEquations()

virtual int nEquations | ( |  | ) | const
| pure virtual

Return the number of equations in the equation system.

Implemented in ResidJacEval.

## ◆ writeSolution()

virtual void writeSolution | ( | int | ievent,
|  | const double | time,
|  | const double | deltaT,
|  | const int | time_step_num,
|  | const double * | y,
|  | const double * | ydot
| ) |  |
| inline virtual

Write out to a file or to standard output the current solution.

ievent is a description of the event that caused this function to be called.

Definition at line 139 of file ResidEval.h.

## ◆ nparams()

int nparams | ( |  | ) | const
| inline

Return the number of parameters in the calculation.

This is the number of parameters in the sensitivity calculation. We have set this to zero and have included it for later expansion

Definition at line 164 of file ResidEval.h.

## Member Data Documentation

## ◆ m_alg

vector<int> m_alg
| protected

Mapping vector that stores whether a degree of freedom is a DAE or not.

The first index is the equation number. The second index is 1 if it is a DAE, and zero if it is not.

Definition at line 174 of file ResidEval.h.

## ◆ m_constrain

map<int, int> m_constrain
| protected

Definition at line 175 of file ResidEval.h.

The documentation for this class was generated from the following file:

- ResidEval.h